<img src="https://raw.githubusercontent.com/agile-ts/agile/master/packages/vue/static/header_background.png" alt="Vue Integration">

> Integrate AgileTs into Vue

 <br />

 <a href="https://github.com/agile-ts/agile">
  <img src="https://img.shields.io/github/license/agile-ts/agile.svg?label=license&style=flat&colorA=293140&colorB=4a4872" alt="GitHub License"/></a>
<a href="https://npm.im/@agile-ts/vue">
  <img src="https://img.shields.io/npm/v/@agile-ts/vue.svg?label=npm&style=flat&colorA=293140&colorB=4a4872" alt="npm version"/></a>
<a href="https://npm.im/@agile-ts/vue">
  <img src="https://img.shields.io/bundlephobia/min/@agile-ts/vue.svg?label=minified%20size&style=flat&colorA=293140&colorB=4a4872" alt="npm minified size"/></a>
<a href="https://npm.im/@agile-ts/vue">
  <img src="https://img.shields.io/npm/dt/@agile-ts/vue.svg?label=downloads&style=flat&colorA=293140&colorB=4a4872" alt="npm total downloads"/></a>


<br />


<br />
<img src="https://raw.githubusercontent.com/agile-ts/agile/master/packages/vue/static/what_does_this_integration_header.png" alt="What does this Integration?"/>

The `vue` package helps us to integrate AgileTs into a [Vue](https://vuejs.org/) environment
and serves as an Interface to Vue.
Its main task is to bind States to Vue Components.
This binding ensures that AgileTs rerender the Component whenever a bound State mutates.
It also offers some other valuable functionalities that optimize the workflow using AgileTs in a Vue project.


<br />


<br />
<img src="https://raw.githubusercontent.com/agile-ts/agile/master/packages/vue/static/installation_header.png" alt="Installation"/>

```
npm install @agile-ts/vue
```
The `vue` package is an extension of AgileTs and doesn't work without the [`core`](https://agile-ts.org/docs/core) package,
which functions as the brain of AgileTs and is indispensable.
Unfortunately, we can't combine each `core` with `vue` version.
Therefore, we have created a table that shows which versions fit together without restrictions.

| @agile-ts/vue    | @agile-ts/core          | NPM Version              | Supported Vue   versions |
| ---------------- | ----------------------- | ------------------------ | -------------------------|
| v0.1.1+          | v0.1.1+                 | v6+                      | 2.x (3.x not tested)     |

_Older Versions aren't supported anymore_


<br />


<br />
<img src="https://raw.githubusercontent.com/agile-ts/agile/master/packages/vue/static/documentation_header.png" alt="Documentation"/>

Sounds AgileTs interesting to you?
Checkout our **[documentation](https://agile-ts.org/docs/vue)**, to learn more.
And I promise you, you will be able to use AgileTs in no time.
If you have any further questions, don't hesitate to join our [Community Discord](https://discord.gg/T9GzreAwPH).


<br />


<br />
<img src="https://raw.githubusercontent.com/agile-ts/agile/master/packages/vue/static/contribute_header.png" alt="Contribute"/>

Get a part of AgileTs and start contributing. We welcome any meaningful contribution. 😀
To find out more about contributing, check out the [CONTRIBUTING.md](https://github.com/agile-ts/agile/blob/master/CONTRIBUTING.md).

<a href="https://codeclimate.com/github/agile-ts/agile/coverage.svg">
   <img src="https://codeclimate.com/github/agile-ts/agile/badges/gpa.svg" alt="Maintainability"/>
</a>
