"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@agile-ts/core");
const vue_1 = __importDefault(require("vue"));
const bindAgileInstances_1 = require("./bindAgileInstances");
const vueIntegration = new core_1.Integration({
    key: 'vue',
    frameworkInstance: vue_1.default,
    updateMethod: (componentInstance, updatedData) => {
        const componentData = componentInstance.$data;
        for (const key of Object.keys(updatedData)) {
            if (Object.prototype.hasOwnProperty.call(componentData, key)) {
                componentData.sharedState[key] = updatedData[key];
            }
            else {
                vue_1.default.set(componentData.sharedState, key, updatedData[key]);
            }
        }
    },
    bind: (agile) => {
        vue_1.default.use({
            install: (vue) => {
                vue.mixin({
                    created: function () {
                        this.$agile = agile;
                    },
                    methods: {
                        bindAgileInstances: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this)),
                            };
                        },
                        bindAgileValues: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this, 'value')),
                            };
                        },
                        bindAgileOutputs: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this, 'output')),
                            };
                        },
                    },
                });
            },
        });
        return Promise.resolve(true);
    },
});
core_1.Integrations.addInitialIntegration(vueIntegration);
exports.default = vueIntegration;
